export declare type EosioAuthorizationObject = {
    actor: string;
    permission: string;
};
export declare type EosioActionObject = {
    account: string;
    name: string;
    authorization: EosioAuthorizationObject[];
    data: any;
};
export declare class ActionGenerator {
    readonly contract: string;
    readonly token_contract: string;
    constructor(contract: string, token_contract: string);
    open(authorization: EosioAuthorizationObject[], owner: string, symbol: string, payer: string): Promise<EosioActionObject[]>;
    close(authorization: EosioAuthorizationObject[], owner: string, symbol: string): Promise<EosioActionObject[]>;
    createPool(authorization: EosioAuthorizationObject[], owner: string, description: string): Promise<EosioActionObject[]>;
    addToWhiteList(authorization: EosioAuthorizationObject[], pool_id: number, user: string): Promise<EosioActionObject[]>;
    stakeToPool(authorization: EosioAuthorizationObject[], from: string, quantity: string, pool_id: string): Promise<EosioActionObject[]>;
    withdrawFromPool(authorization: EosioAuthorizationObject[], owner: string, quantity: string): Promise<EosioActionObject[]>;
    protected _pack(account: string, authorization: EosioAuthorizationObject[], name: string, data: any): EosioActionObject[];
}
